Libargus API Libargus Camera API

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions
Argus::ISourceSettings Class Reference
SourceSettings

Interface to the source settings (provided by IRequest::getSourceSettings()). More...

`#include <Settings.h>`

Inheritance diagram for Argus::ISourceSettings:

List of all members.

## Public Member Functions
virtual Status | setExposureTimeRange (const Range< uint64_t > &exposureTimeRange)=0
| Sets the exposure time range of the source, in nanoseconds.
virtual Range< uint64_t > | getExposureTimeRange () const =0
| Returns the exposure time range of the source, in nanoseconds.
virtual Status | setFocusPosition (int32_t position)=0
| Sets the focus position, in focuser units.
virtual int32_t | getFocusPosition () const =0
| Returns the focus position, in focuser units.
virtual Status | setFrameDurationRange (const Range< uint64_t > &frameDurationRange)=0
| Sets the frame duration range, in nanoseconds.
virtual Range< uint64_t > | getFrameDurationRange () const =0
| Returns the frame duration range, in nanoseconds.
virtual Status | setGainRange (const Range< float > &gainRange)=0
| Sets the gain range for the sensor.
virtual Range< float > | getGainRange () const =0
| Returns the gain range.
virtual Status | setSensorMode (SensorMode *mode)=0
| Sets the sensor mode.
virtual SensorMode * | getSensorMode () const =0
| Returns the sensor mode.
virtual Status | setOpticalBlack (const BayerTuple< float > &opticalBlackLevels)=0
| Sets the user-specified optical black levels.
virtual BayerTuple< float > | getOpticalBlack () const =0
| Returns user-specified opticalBlack level per bayer phase.
virtual Status | setOpticalBlackEnable (bool enable)=0
| Sets whether or not user-provided optical black levels are used.
virtual bool | getOpticalBlackEnable () const =0
| Returns whether user-specified optical black levels are enabled.

## Static Public Member Functions
static const InterfaceID & | id ()

## Protected Member Functions
| ~ISourceSettings ()
Protected Member Functions inherited from Argus::Interface
| Interface ()
| ~Interface ()

## Detailed Description

Interface to the source settings (provided by IRequest::getSourceSettings()).

Definition at line 50 of file Settings.h.

## Constructor & Destructor Documentation

Argus::ISourceSettings::~ISourceSettings | ( |  | ) |
| inline protected

Definition at line 173 of file Settings.h.

## Member Function Documentation

virtual Range<uint64_t> Argus::ISourceSettings::getExposureTimeRange | ( |  | ) | const
| pure virtual

Returns the exposure time range of the source, in nanoseconds.

virtual int32_t Argus::ISourceSettings::getFocusPosition | ( |  | ) | const
| pure virtual

Returns the focus position, in focuser units.

virtual Range<uint64_t> Argus::ISourceSettings::getFrameDurationRange | ( |  | ) | const
| pure virtual

Returns the frame duration range, in nanoseconds.

virtual Range<float> Argus::ISourceSettings::getGainRange | ( |  | ) | const
| pure virtual

Returns the gain range.

virtual BayerTuple<float> Argus::ISourceSettings::getOpticalBlack | ( |  | ) | const
| pure virtual

Returns user-specified opticalBlack level per bayer phase.

Returns:
  opticalBlackLevels

virtual bool Argus::ISourceSettings::getOpticalBlackEnable | ( |  | ) | const
| pure virtual

Returns whether user-specified optical black levels are enabled.

If false, the Argus implementation will choose the optical black values.

See also:
  setOpticalBlackEnable()

Returns:
  enable

virtual SensorMode* Argus::ISourceSettings::getSensorMode | ( |  | ) | const
| pure virtual

Returns the sensor mode.

static const InterfaceID& Argus::ISourceSettings::id | ( |  | ) |
| inline static

Definition at line 53 of file Settings.h.

virtual Status Argus::ISourceSettings::setExposureTimeRange | ( | const Range< uint64_t > & | exposureTimeRange | ) |
| pure virtual

Sets the exposure time range of the source, in nanoseconds.

If the exposure range is outside of the available range, the capture's exposure time will be as close as possible to the exposure range specified.

Parameters:

  [in] | exposureTimeRange | Exposure time range, in nanoseconds.

See also:
  ISensorMode::getExposureTimeRange()

Todo:
  Document implications of quantization.

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setFocusPosition | ( | int32_t | position | ) |
| pure virtual

Sets the focus position, in focuser units.

If the position is set outside of the focuser limits, the position will be clamped.

Parameters:

  [in] | position | The new focus position, in focuser units.

See also:
  ICameraProperties::getFocusPositionRange()

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setFrameDurationRange | ( | const Range< uint64_t > & | frameDurationRange | ) |
| pure virtual

Sets the frame duration range, in nanoseconds.

If frame range is out of bounds of the current sensor mode, the capture's frame duration will be as close as possible to the range specified.

Parameters:

  [in] | frameDurationRange | Frame duration range, in nanoseconds

See also:
  ISensorMode::getFrameDurationRange()

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setGainRange | ( | const Range< float > & | gainRange | ) |
| pure virtual

Sets the gain range for the sensor.

The range has to be within the max and min reported in the CameraProperties Otherwise the range will be clipped.

Parameters:

  [in] | gainRange | scalar gain range

See also:
  ISensorMode::getAnalogGainRange()

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setOpticalBlack | ( | const BayerTuple< float > & | opticalBlackLevels | ) |
| pure virtual

Sets the user-specified optical black levels.

These values will be ignored unless `getOpticalBlackEnable() == true` Values are floating point in the range [0,1) normalized based on sensor bit depth.

Parameters:

  [in] | opticalBlackLevels | opticalBlack levels in range [0,1) per bayer phase

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setOpticalBlackEnable | ( | bool | enable | ) |
| pure virtual

Sets whether or not user-provided optical black levels are used.

Parameters:

  [in] | enable | If `true`, Argus will use the user-specified optical black levels.

See also:
  setOpticalBlack() If `false`, the Argus implementation will choose the optical black values.

Returns:
  success/status of the call.

virtual Status Argus::ISourceSettings::setSensorMode | ( | SensorMode * | mode | ) |
| pure virtual

Sets the sensor mode.

Note that changing sensor mode from one capture to the next may result in multiple sensor frames being dropped between the two captures.

Parameters:

  [in] | mode | Desired sensor mode for the capture.

See also:
  ICameraProperties::getAllSensorModes()

Returns:
  success/status of the call.

The documentation for this class was generated from the following file:

- include/Argus/Settings.h